#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include <stdlib.h>
#include <avr/eeprom.h>
#include <avr/interrupt.h>

#define NEW_GAME 1
#define BOARD -1

#define EASY 1
#define MEDIUM 2
#define HARD 3
#define MAX_TIME 20

#define MOVE_BTN PD2
#define SELECT_BTN PD3
#define BUZZER_BTN PD4

#define LCD_WIDTH 84
#define LCD_HEIGHT 48

#define BIRD_LENGTH 9
#define BIRD_HEIGTH 6

#define PIPE_WIDTH 6
#define eps 1

// eeprom memory
#define read_eeprom_word(address) eeprom_read_word ((const uint16_t*)address)
#define write_eeprom_word(address,value) eeprom_write_word ((uint16_t*)address,(uint16_t)value)
#define update_eeprom_word(address,value) eeprom_update_word ((uint16_t*)address,(uint16_t)value)

unsigned int EEMEM  eeprom[6];
/* saves the pixels for the bird's shape */
char bird_mat[6][9] = { 
						{0, 0, 0, 0, 1, 1, 1, 1, 0},
						{0, 0, 1, 1, 1, 0, 0, 1, 0},
						{0, 1, 1, 0, 0, 0, 1, 0, 1},
						{1, 1, 0, 0, 0, 0, 0, 1, 1},
						{0, 1, 1, 0, 0, 1, 1, 1, 0},
						{0, 0, 0, 1, 1, 1, 0, 0, 0},
};

typedef struct position{
	char x;
	char y;
} Position;

int option = 1;
int difficulty = 1;
int turn;
int score;
char in_game = 0;
int PIPE_SPACE = 20;
int PIPE_TURN = 45;

Position bird;
int speed = 1;
char pipe_x[100];
char pipe_h[100];
int pipe_cnt;
int pipe_start;

int timer_counter = 0;
int time_over = 0;

void init_buttons();
void init_bird();
void init_timer();
void display_bird();
void main_scree();
void game();
void new_game();
void leaderboard();
void select_mode();
void end_screen();
void new_pipe(int index);
void display_pipe(int index);
int check_collision();
void difficulty_screen();
void select_difficulty();
void lose_sound();
void point_sound();