#ifndef _NOKIALCD_H_
#define _NOKIALCD_H_

/* Lcd screen size */
#define LCD_X_RES 84
#define LCD_Y_RES 48
#define LCD_CACHE_SIZE ((LCD_X_RES * LCD_Y_RES) / 8)

/* Pinout for LCD */
#define LCD_CLK_PIN 	(1<<PB7)
#define LCD_DATA_PIN 	(1<<PB6)
#define LCD_DC_PIN 	(1<<PB5)
#define LCD_CE_PIN 	(1<<PB4)
#define LCD_RST_PIN 	(1<<PB3)
#define LCD_PORT	PORTB
#define LCD_DDR		DDRB

/* Special Chars */
#define ARROW_RIGHT	'z' + 1
#define ARROW_LEFT 	'z' + 2

/* delay macro function */
#define lcd_delay() for(volatile int i=-32000;i<32000;i++)

void lcd_init(void);
void lcd_contrast(unsigned char contrast);
void lcd_clear(void);
void lcd_clear_area(unsigned char line, unsigned char startX, unsigned char endX);
void lcd_clear_line(unsigned char line);
void lcd_goto_xy(unsigned char x, unsigned char y);
void lcd_goto_xy_exact(unsigned char x, unsigned char y);
void lcd_chr(char chr);
void lcd_str(char* str);
void lcd_update(void);
void lcd_draw_pixel(unsigned char x, unsigned char y);
void lcd_base_addr_(unsigned char x, unsigned char y);

#endif
